#include "stdafx.h"
#include <windows.h>
#include <Commctrl.h>
#include <vector>

//#include "zTrace.h"   // Search in the same directory of the current file.
#pragma comment(lib, "..\\GDImage64.lib")
//#pragma comment(lib, "..\\GDImage32.lib")
#include "GDImage.h"
#pragma comment(lib, "..\\WinLIFT64.lib")
//#pragma comment(lib, "..\\WinLIFT32.lib")
#include "WinLIFT.h"  // Search in the same directory of the current file.

#include "Tools.h"

#define _SCL_SECURE_NO_WARNINGS // No warning message when using sprintf, strcopy, etc.

#define NM_AUDIOCOMPLETION  NM_FIRST - 80

#define MyWindowWidth       800 // This value is for the initial 4/3 window size, but it is resized to 16/9 just before being displayed.
#define MyWindowHeight      614 // This value is for the initial 4/3 window size, but it is resized to 16/9 just before being displayed.

#define IDC_STATIC          -101
#define IDC_MAIN_GDIMAGE    1001
#define IDC_MAIN_SLIDEZOOM  1002
#define IDC_MAIN_CHECKBOX   1003
#define IDC_MAIN_CLOCK      1004
#define IDC_MAIN_KNOBLEFT   1005
#define IDC_MAIN_KNOBBIG    1006
#define IDC_MAIN_KNOBRIGHT  1007
#define IDC_MAIN_LOADIMAGE  1008
#define IDC_MAIN_STATICIMG  1009
#define IDC_MAIN_PLUGIN     1010
#define IDC_MAIN_WALLPAPER  1011

#define IDC_CB_PLUGIN       1012
#define IDC_CB_AUDIO        1013

// GDImage constant to identify each sprite image.
#define ID_PHOTO            1
#define ID_LOGO             2
#define ID_SPIN01           3
#define ID_SPIN02           4
#define ID_SPIN03           5

#define TIMER_DELAY         33 // Initial animation value.

// Global variables
HINSTANCE gh_Inst;    // Current instance
HWND gh_ImageCtrl, gh_Main;
wstring gs_AudioPath, gs_PluginPath, gs_Resource;
long gn_FocusID, gn_TrueWidth, gn_TrueHeight, gn_UseWidth, gn_UseHeight, gn_Delay;
float gr_WasZoom;
long WM_ZWPNOTIFICATION;

// Declaration of the functions being used in this module:
HWND    ZWP_Handle();

void Animate (IN LPVOID Delay) {
    DWORD nWait = 0;
    long nFrame;
    for (;;) {
        nFrame = ZD_GetObjectFrameToUse(ID_SPIN01) + 1; if (nFrame > ZD_GetObjectFrameCount(ID_SPIN01)) { nFrame = 1; }
        ZD_SetObjectFrameToUse(ID_SPIN01, nFrame, FALSE);

        nFrame = ZD_GetObjectFrameToUse(ID_SPIN02) + 1; if (nFrame > ZD_GetObjectFrameCount(ID_SPIN02)) { nFrame = 1; }
        ZD_SetObjectFrameToUse(ID_SPIN02, nFrame, FALSE);

        nFrame = ZD_GetObjectFrameToUse(ID_SPIN03) + 1; if (nFrame > ZD_GetObjectFrameCount(ID_SPIN03)) { nFrame = 1; }
        ZD_SetObjectFrameToUse(ID_SPIN03, nFrame, TRUE);

        Sleep((long) gn_Delay);
    }
}

long StartAnimation (IN long Delay) {
    long nRet = LB_ERR;
    gn_Delay = Delay;
    DWORD dwThreadId = 0;
    HANDLE hThread = CreateThread(NULL,                                  // default security attributes
                                  0,                                     // use default stack size  
                                  (LPTHREAD_START_ROUTINE ) Animate,     // thread function name
                                  (LPVOID) Delay,                        // argument to thread function 
                                  0,                                     // use default creation flags 
                                  &dwThreadId);                          // returns the thread identifier
    if (hThread) { nRet = 0; Sleep(100); }
    CloseHandle(hThread);
    return nRet;
}

void ComboSelectPlus (IN HWND hCombo, IN long nSelected) {
    if (nSelected > 0) { nSelected -= 1; } // Because ListBox is zero based.
    if (hCombo) { SendMessage(hCombo, CB_SETCURSEL, nSelected, 0); }
}

void DetectAudio (IN HWND hCombo, IN long nUseItem) {

    if (!hCombo) return;

    long nCount = 0, nPos = 0;
    HANDLE hFind = 0;
    WIN32_FIND_DATAW fd;
    WCHAR zTmp[MAX_PATH] = {0};
    WCHAR zExt[8] = {0};
    wstring sExt;

    SendMessage(hCombo, CB_RESETCONTENT, 0, 0);

    wstring sAudio = L".xm.mod.it.s3m.mo3.mp3.ogg.wav.";
    wstring sSearch = gs_AudioPath; sSearch += L"*.*";
    wcscpy_s(zTmp, (WCHAR*) sSearch.c_str());
    hFind = FindFirstFile(zTmp, &fd);
    nCount = 0;
    nPos = 0;
    if (hFind != INVALID_HANDLE_VALUE) {
       int IsOk = -1;
       while (IsOk != 0) {
          if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
             sSearch = fd.cFileName;
             wcscpy_s(zTmp, (WCHAR*) sSearch.c_str());
             nPos = (long) sSearch.find_last_of(L"."); // Extract extension.
             sExt = sSearch.substr(nPos); sExt += L".";
             wcscpy_s(zExt, (WCHAR*) sExt.c_str());
             CharLower(zExt);
             nPos = (long) sAudio.find(zExt);
             if (nPos > -1) {
                if (SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM) zTmp) > -1) {
                   nCount += 1;
                }
             }
          }
          if (FindNextFile(hFind, &fd) == false) { IsOk = 0; }
       }
       FindClose(hFind);
    }

    if (nCount) {
       if (nUseItem > nCount) { nUseItem = 1; }
       ComboSelectPlus(hCombo, nUseItem);
    }
}

void DetectPlugin (HWND hCombo, long nUseItem) {

    if (!hCombo) return;

    long nCount, nPos;
    HANDLE hFind;
    WIN32_FIND_DATAW fd;
    WCHAR zTmp[MAX_PATH];
    WCHAR zExt[8];
    wstring sExt;

    SendMessage(hCombo, CB_RESETCONTENT, 0, 0);

    wstring sSearch = gs_PluginPath; sSearch += L"*.dll";
    wcscpy_s(zTmp, (WCHAR*) sSearch.c_str());
    hFind = FindFirstFile(zTmp, &fd);
    nCount = 0;
    if (hFind != INVALID_HANDLE_VALUE) {
       int IsOk = -1;
       while (IsOk != 0) {
          if (!(fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
             sSearch = fd.cFileName;
             wcscpy_s(zTmp, (WCHAR*) sSearch.c_str());
             nPos = (long) sSearch.find_last_of(L"."); // Extract extension.
             sExt = sSearch.substr(nPos); sExt += L".";
             wcscpy_s(zExt, (WCHAR*) sExt.c_str());
             CharLower(zExt);
             sExt = zExt;
             if (!sExt.compare(L".dll.")) { // Check if the two strings are the same
                if (SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM) zTmp) > -1) {
                    nCount += 1;
                    if ((_wcsicmp(zTmp, L"Hud_Beam.dll") == 0) && (nUseItem == 0)) { nUseItem = nCount; }
                }
             }
          }
          if (FindNextFile(hFind, &fd) == false) { IsOk = 0; }
       }
       FindClose(hFind);
    }

    if (nCount) {
       if (nUseItem > nCount) { nUseItem = 1; }
       ComboSelectPlus(hCombo, nUseItem);
    }
}

void ZWP_SizeMove() {
    RECT lpw;
    int x, y, w, h;
    HWND hWnd, hPopup;
    GetWindowRect(gh_Main, &lpw);
    x = lpw.left + skGetSystemMetrics(SK_DWM_LEFT);
    y = lpw.top + skGetSystemMetrics(SK_DWM_TOP);
    w = lpw.right - skGetSystemMetrics(SK_DWM_RIGHT) - x;
    h = lpw.bottom - skGetSystemMetrics(SK_DWM_BOTTOM) - y;

    // Use this to move the window in case of AERO shake
    // because setting the new location with SetWindowPos
    // may fail!
    hWnd = ZWP_Handle();
    if (hWnd) {
        hPopup = skGetDWMregion(gh_Main);
        if (hPopup == 0) { hPopup = gh_Main; }
    
        SetWindowPos(hWnd, GetWindow(hPopup, GW_HWNDNEXT), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOOWNERZORDER | SWP_NOACTIVATE | SWP_ASYNCWINDOWPOS);
        MoveWindow(hWnd, x, y, w, h, 0);
    }
}

long ZWP_Message(wstring wS) {
    string sMsg = ws2s(wS);
    char szText[512];
    strncpy_s(szText, sMsg.c_str(), sMsg.size() );
    long nRet = (long) SendMessageA(ZWP_Handle(), WM_SETTEXT, 0, (LPARAM) szText);
    return nRet;
}

HWND ZWP_Handle() {
    static HWND hZWP;
    if (hZWP == 0) {
       char zClass[] = "ZWALLPAPER";
       hZWP = FindWindowA(zClass, zClass);
       if (hZWP) {
          ZWP_SizeMove();
          string sMsg = "PARENT,";
          char szStr[12];
          sprintf_s(szStr, "% d", gh_Main);
          sMsg += szStr;
          sMsg += ",";
          sprintf_s(szStr, "% d", IDC_MAIN_WALLPAPER);
          sMsg += szStr;
          ZWP_Message(stringW(sMsg));
       }
    }
    return hZWP;
}

void ZWP_Play(wstring sAudio) {
    wstring sMsg = L"PLAY,"; sMsg += sAudio;
    ZWP_Message(sMsg);
}

void ZWP_Stop() {
    ZWP_Message(L"STOP");
}

void ZWP_Hide() {
    ShowWindow(ZWP_Handle(), SW_HIDE);
    ZWP_Stop();
}

void ZWP_Destroy() {
    ZWP_Message(L"DESTROY");
}

void ZWP_UsePlugin(wstring sPlugin) {
    wstring sCommand = L"PLUGIN,"; sCommand += sPlugin;
    ZWP_Message(sCommand);
}

void ZWP_Show(wstring sAudio) {
    RECT lpw;
    long x, y, w, h;
    HWND hWnd, hPopup;
    GetWindowRect(gh_Main, &lpw);
    x = lpw.left + skGetSystemMetrics(SK_DWM_LEFT);
    y = -2000;
    w = lpw.right - skGetSystemMetrics(SK_DWM_RIGHT) - x;
    h = lpw.bottom - skGetSystemMetrics(SK_DWM_BOTTOM) - y;

    // Use this to move the window in case of AERO shake
    // because setting the new location with SetWindowPos
    // may fail!
    hWnd = ZWP_Handle();
    hPopup = skGetDWMregion(gh_Main);
    if (hPopup == 0) { hPopup = gh_Main; }
    SetWindowPos(hWnd, GetWindow(hPopup, 2), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOOWNERZORDER | SWP_NOACTIVATE);
    MoveWindow(hWnd, x, y, w, h, 0);

    ZWP_SizeMove();
    ZWP_Play(sAudio);
    ShowWindow(hWnd, SW_SHOW);
}

void UseThisZoom(long nPos) {
    if (gn_FocusID) {
       HWND hCtrl;
       float rZoomValue;

       rZoomValue = float (nPos * 0.001);
       if (rZoomValue != gr_WasZoom) {
          hCtrl = ZD_GetObjectParent(gn_FocusID);
          // Make sure to disable the crop rectangle if any
          if (ZI_GetToolCropStatus(hCtrl)) { ZI_DisableCropRectangle(hCtrl); }

          ZD_SetObjectScale(gn_FocusID, rZoomValue);
          ZI_UpdateWindow(hCtrl, FALSE);

       }
       gr_WasZoom = rZoomValue;
    }
}

void GDImageSetZoomRange(long bmW, long bmH, long &xSize, long &ySize) {
    RECT lpr = {0};
    long xPos = 0, yPos = 0;
    HWND hCtrl = 0;
    GetClientRect(gh_ImageCtrl, &lpr);
    ZI_Iconise(bmW, bmH, lpr.right, lpr.bottom, xPos, yPos, xSize, ySize);
    hCtrl = GetDlgItem(gh_Main, IDC_MAIN_SLIDEZOOM);
    SendMessage(hCtrl, TBM_SETRANGE, 1, MAKELONG((int)((xSize / bmW) * 128), 1500));
}

void UseThisPhoto(WCHAR* sUsePhoto, long bReset) {

    RECT lpr = {0};
    HBITMAP hBitmap = 0;
    long nW = 0, nH = 0, nX = 0, nY = 0, nSizeX = 0, nSizeY = 0, nPosAngle = 0;
    float rAspect = 0.0f, rZoomValue = 0.0f;

    // Make sure to disable the crop rectangle if any
    if (ZI_GetToolCropStatus(gh_ImageCtrl)) { ZI_DisableCropRectangle(gh_ImageCtrl); }

    ZI_GetImageSizeFromFile(sUsePhoto, gn_TrueWidth, gn_TrueHeight);
    nW = max(gn_TrueWidth, gn_TrueHeight);
    if (nW > 1024) { nW = 1024; }
    hBitmap = ZI_FitBitmapFromFile(sUsePhoto, nW, nW);
    ZI_GetBitmapSize(hBitmap, nW, nH);


    if (hBitmap) {
       gn_UseWidth = nW; gn_UseHeight = nH;

       // Compute range based on the image size
       GDImageSetZoomRange(gn_UseWidth, gn_UseHeight, nSizeX, nSizeY);

       GetClientRect(gh_ImageCtrl, &lpr);
       ZI_Iconise(gn_TrueWidth, gn_TrueHeight, lpr.right, lpr.bottom, nX, nY, nW, nH);
       if (nW > nH) {
          rAspect = float (nW / nH); }
       else {
          rAspect = 1;
       }

       rZoomValue = float (nSizeX / (gn_UseWidth / rAspect));
       SendMessage(GetDlgItem(gh_Main, IDC_MAIN_SLIDEZOOM), TBM_SETPOS, 1, (LPARAM)(rZoomValue * 1000));

       GetClientRect(gh_ImageCtrl, &lpr);
       nX = (lpr.right - gn_UseWidth) / 2;
       nY = (lpr.bottom - gn_UseHeight) / 2;

       ZD_DrawBitmapToCtrl(gh_ImageCtrl, nX, nY, hBitmap, ZD_ColorARGB(255, 0), ID_PHOTO, ZS_HIDDEN); // ZS_VISIBLE)
       ZD_SetObjectScale(ID_PHOTO, rZoomValue);

       nPosAngle = skGaugeGetPos(GetDlgItem(gh_Main, IDC_MAIN_KNOBBIG));
       ZD_SetObjectAngle(ID_PHOTO, nPosAngle, FALSE);
       ZD_SetObjectAnchorMode(ID_PHOTO, ANCHOR_CENTER);

       SetFocus(gh_ImageCtrl);
       ZI_SetObjectFocusID(ID_PHOTO);
       gn_FocusID = ID_PHOTO;

       ZD_SetObjectVisibility(ID_PHOTO, ZS_VISIBLE);
       ZI_UpdateWindow(gh_ImageCtrl, 0);
    }
}

void UseThisAnimation(WCHAR* sUsePhoto, long ID_OBJECT) {

    RECT lpr = {0};
    HBITMAP hBitmap = 0;
    long nW = 0, nH = 0, nX = 0, nY = 0, nSizeX = 0, nSizeY = 0, nPosAngle = 0, nReserved = 0, nFrameCount = 0;
    float rAspect = 0.0f, rZoomValue = 0.0f;

    // Make sure to disable the crop rectangle if any
    if (ZI_GetToolCropStatus(gh_ImageCtrl)) { ZI_DisableCropRectangle(gh_ImageCtrl); }

    hBitmap = skSkiToDib (sUsePhoto, nReserved);
    if (hBitmap) {
       ZI_GetBitmapSize(hBitmap, nW, nH);
       nFrameCount = nW / nH; nW = nH;
       gn_UseWidth = nW; gn_UseHeight = nH;

       // Compute range based on the image size
       GDImageSetZoomRange(gn_UseWidth, gn_UseHeight, nSizeX, nSizeY);

       GetClientRect(gh_ImageCtrl, &lpr);
       ZI_Iconise(gn_TrueWidth, gn_TrueHeight, lpr.right, lpr.bottom, nX, nY, nW, nH);
       if (nW > nH) {
          rAspect = float (nW / nH); }
       else {
          rAspect = 1;
       }

       rZoomValue = float (nSizeX / (gn_UseWidth / rAspect));
       SendMessage(GetDlgItem(gh_Main, IDC_MAIN_SLIDEZOOM), TBM_SETPOS, 1, (LPARAM)(rZoomValue * 1000));

       GetClientRect(gh_ImageCtrl, &lpr);
       nX = (lpr.right - gn_UseWidth) / 2;
       nY = (lpr.bottom - gn_UseHeight) / 2;

       ZD_DrawBitmapToCtrl(gh_ImageCtrl, nX, nY, hBitmap, ZD_ColorARGB(255, 0), ID_OBJECT, ZS_HIDDEN); // ZS_VISIBLE)
       ZD_SetObjectFrameCount(ID_OBJECT, (BYTE) nFrameCount);
       ZD_SetObjectFrameToUse(ID_OBJECT, 1, FALSE);
       ZD_SetObjectScale(ID_OBJECT, rZoomValue);

       nPosAngle = skGaugeGetPos(GetDlgItem(gh_Main, IDC_MAIN_KNOBBIG));
       ZD_SetObjectAngle(ID_OBJECT, nPosAngle, FALSE);

       // We must reset the centerx property in order to center the ID_OBJECT correctly
       // because we reuse the same ID with sprites of different size. 
       ZOBJECT zObj; ZD_GetObjectProperties(ID_OBJECT, zObj); 
       zObj.centerx = 0; // We must reset this property in order to anchor it correctly below.
       ZD_SetObjectProperties(ID_OBJECT, zObj);

       ZD_SetObjectAnchorMode(ID_OBJECT, ANCHOR_CENTER); // zObj.centerx must be set to NULL first

       SetFocus(gh_ImageCtrl);
       ZI_SetObjectFocusID(ID_OBJECT);
       gn_FocusID = ID_OBJECT;

       ZD_SetObjectVisibility(ID_OBJECT, ZS_VISIBLE);
       ZI_UpdateWindow(gh_ImageCtrl, 0);
    }
}

// Main winproc
LRESULT CALLBACK WndProc(IN HWND hWnd, IN UINT uMsg, IN WPARAM wParam, IN LPARAM lParam) {

    HWND hPopup = 0, hDW = 0, hCtrl = 0;
    long wmId = 0, wmEvent = 0, nRet = 0, nPos = 0;
    wstring sUseFile, sResource;
    WCHAR szFile[MAX_PATH] = {0};
    NMHDR* pNMHDR;
    PAINTSTRUCT ps = {0}; HDC hdc = 0;
    HDROP hfInfo = {0};

    if (uMsg == WM_ZWPNOTIFICATION) {
        switch (wParam) {
        case NM_AUDIOCOMPLETION:
             // Uncheck VisualPlugin
             SendMessage(GetDlgItem(hWnd, IDC_MAIN_PLUGIN), BM_SETCHECK, BST_UNCHECKED, 0);
             ZWP_Hide();
             hPopup = skGetDWMregion(hWnd);
             if (hPopup) {
                SetWindowPos(hPopup, GetWindow(hWnd, 2), 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOOWNERZORDER | SWP_NOACTIVATE | SWP_SHOWWINDOW);
                SetFocus(hWnd);
             }
             break;
        }
        return 0;
    }

    switch (uMsg) {

    case WM_DROPFILES:
         hfInfo = HDROP(wParam);
         nRet = DragQueryFileA(hfInfo, 0xFFFFFFFF, NULL, 0);
         if (nRet > 0) {
             nRet = DragQueryFile(hfInfo, 0, szFile, MAX_PATH);
             if (nRet) { 
                 SendMessage(GetDlgItem(hWnd, IDC_MAIN_PLUGIN), BM_SETCHECK, BST_CHECKED, 0);
                 hPopup = skGetDWMregion(hWnd);
                 if (hPopup) { ShowWindow(hPopup, SW_HIDE); }
                 ZWP_Show(szFile);
             }
         }
         DragFinish(hfInfo);
         SetForegroundWindow(hWnd);
         break;

    case WM_PAINT:
         hdc = BeginPaint(hWnd, &ps);
         // TODO: process here the WM_PAINT message...
         EndPaint(hWnd, &ps);
         return 0;

    case WM_NOTIFY:
         pNMHDR = (NMHDR*) lParam;
         // Assign the new rotation angle to the sprite image.
         nPos = pNMHDR->code;
         switch (pNMHDR->idFrom) {  

         case IDC_MAIN_KNOBBIG:
              ZD_SetObjectAngle(gn_FocusID, nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBLEFT), nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBRIGHT), nPos, TRUE);
              break;
         case IDC_MAIN_KNOBLEFT:
              ZD_SetObjectAngle(gn_FocusID, nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBBIG), nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBRIGHT), nPos, TRUE);
              break;
         case IDC_MAIN_KNOBRIGHT:
              ZD_SetObjectAngle(gn_FocusID, nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBBIG), nPos, TRUE);
              skGaugeSetPos(GetDlgItem(hWnd, IDC_MAIN_KNOBLEFT), nPos, TRUE);
              break;
         }
         return 0;

    case WM_SIZE:
    case WM_MOVE:
    case WM_WINDOWPOSCHANGED:
    case WM_IME_NOTIFY:
         if (ZWP_Handle()) {
            ZWP_SizeMove();
         }
         break;

    case WM_COMMAND:
         wmId    = LOWORD(wParam);
         wmEvent = HIWORD(wParam);

         // Process menu command
         switch (wmId) {

         case IDC_MAIN_LOADIMAGE:
              hDW = skCreateDW(hWnd);
              wcscpy_s(szFile, ZI_LoadDialog(hWnd));
              skDestroyDW(hDW);

              if (wcslen(szFile)) {
                  UseThisPhoto(szFile, 0);
              }
              break;

         case IDC_MAIN_CHECKBOX:
              nRet = (long) SendMessage(GetDlgItem(hWnd, IDC_MAIN_CHECKBOX), BM_GETCHECK, 0, 0);
              if (nRet == BST_CHECKED) {
                 ZI_UseWinLIFTbackground(gh_ImageCtrl, FALSE, TRUE); }
              else {
                 ZI_UseWinLIFTbackground(gh_ImageCtrl, TRUE, TRUE);
              }
              SetFocus(gh_ImageCtrl);
              break;

         case IDC_MAIN_PLUGIN:
              nRet = (long) SendMessage(GetDlgItem(hWnd, IDC_MAIN_PLUGIN), BM_GETCHECK, 0, 0);
              if (nRet == BST_CHECKED) {
                 hCtrl = GetDlgItem(hWnd, IDC_CB_AUDIO);
                 SendMessage(hCtrl, CB_GETLBTEXT, SendMessage(hCtrl, CB_GETCURSEL, 0, 0), (LPARAM) szFile);
                 hPopup = skGetDWMregion(hWnd);
                 if (hPopup) { ShowWindow(hPopup, SW_HIDE); }
                 sUseFile = gs_AudioPath; sUseFile += (WCHAR*) szFile;
                 wcscpy_s(szFile, (WCHAR*) sUseFile.c_str());
                 ZWP_Show(szFile); }
              else {
                 hPopup = skGetDWMregion(hWnd);
                 if (hPopup) { ShowWindow(hPopup, SW_SHOW); }
                 ZWP_Hide();
              }
              SetFocus(gh_ImageCtrl);
              break;

         case IDC_CB_PLUGIN:
              if (wmEvent == CBN_SELENDOK) {
                 hCtrl = GetDlgItem(hWnd, IDC_CB_PLUGIN);
                 SendMessage(hCtrl, CB_GETLBTEXT, SendMessage(hCtrl, CB_GETCURSEL, 0, 0), (LPARAM) szFile);


                 if (_wcsicmp(szFile, L"Hud_Matrix.dll") == 0) {
                     sUseFile = gs_Resource; sUseFile += L"dgirl256.ski"; }
                 else if (_wcsicmp(szFile, L"Hud_Attractor.dll") == 0) {
                     sUseFile = gs_Resource; sUseFile += L"attractor.ski"; }
                 else if (_wcsicmp(szFile, L"Hud_Bubble.dll") == 0) {
                     sUseFile = gs_Resource; sUseFile += L"bubble.ski"; }
                 else if (_wcsicmp(szFile, L"Hud_Hal.dll") == 0) {
                     sUseFile = gs_Resource; sUseFile += L"hal.ski"; }
                 else {
                     sUseFile = gs_Resource; sUseFile += L"bighead.ski";
                 }
                 UseThisAnimation((WCHAR*) sUseFile.c_str(), ID_SPIN03);


                 sUseFile = gs_PluginPath; sUseFile += szFile;
                 wcscpy_s(szFile, (WCHAR*) sUseFile.c_str());
                 ZWP_UsePlugin(szFile);

                 SetFocus(gh_ImageCtrl);
              }
              break;

         case IDC_CB_AUDIO:
              if (wmEvent == CBN_SELENDOK) {
                  nRet = (long) SendMessage(GetDlgItem(hWnd, IDC_MAIN_PLUGIN), BM_GETCHECK, 0, 0);
                  if (nRet == BST_CHECKED) {
                      hCtrl = GetDlgItem(hWnd, IDC_CB_AUDIO);
                      SendMessage(hCtrl, CB_GETLBTEXT, SendMessage(hCtrl, CB_GETCURSEL, 0, 0), (LPARAM) szFile);
                      sUseFile = gs_AudioPath; sUseFile += szFile;
                      wcscpy_s(szFile, (WCHAR*) sUseFile.c_str());
                      ZWP_Play(szFile);
                  }
                  SetFocus(gh_ImageCtrl);
              }
              break;

         }
         return 0;

    case WM_VSCROLL:
         nRet = GetDlgCtrlID((HWND) lParam);
         if (nRet == IDC_MAIN_SLIDEZOOM) {
            UseThisZoom((long) SendMessage((HWND) lParam, TBM_GETPOS, 0, 0)); // Do not use nPosition, because it could be NULL.
         }
         break;

    case WM_CLOSE:
         hPopup = skGetDWMregion(hWnd);
         // Hide DWMregion if any.
         if (hPopup) { MoveWindow(hPopup, 0, 0, 0, 0, 1); }
         break;

    case WM_DESTROY:
         DragAcceptFiles(hWnd, 0);
         ZWP_Destroy();
         PostQuitMessage(0);
         return 0;
    }

    return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

int WINAPI wWinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow) {

    UNREFERENCED_PARAMETER(hPrevInstance);
    UNREFERENCED_PARAMETER(lpCmdLine);

    // Check if ZWP is already running.
    char zClass[] = "ZWALLPAPER"; 
    HWND hZWP = FindWindowA(zClass, zClass);

    // Important: we use RegisterWindowMessage to communicate with ZWP's plugins.
    WM_ZWPNOTIFICATION = RegisterWindowMessageA("ZWPnotification");

    // Declaration of local variables
    MSG msg;
    long nRet = 0;
    long k = 0, IsInitialized = 0;
    WNDCLASSEX wcx;
    WCHAR szWindowClass[] = L"ZHUDPLUS";
    WCHAR szTitle[20] = {0};
    if (sizeof(LONG_PTR) == 8) {
        wcscpy_s(szTitle, L"HUD window 64-bit");} 
    else {
        wcscpy_s(szTitle, L"HUD window 32-bit");
    }
    WCHAR szFullpathToFile[MAX_PATH] = {0};

    // Register the main window class
    wcx.cbSize = sizeof(wcx);
    IsInitialized = GetClassInfoEx(hInstance, szWindowClass, &wcx);
    if (!IsInitialized) {
       wcx.style         = CS_HREDRAW | CS_VREDRAW;
       wcx.lpfnWndProc   = WndProc;
       wcx.cbClsExtra    = 0;
       wcx.cbWndExtra    = 0;
       wcx.hInstance     = hInstance;
       wcx.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
       wcx.hCursor       = LoadCursor(NULL, IDC_ARROW);
       wcx.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
       wcx.lpszMenuName  = NULL;
       wcx.lpszClassName = szWindowClass;
       wcx.hIconSm       = LoadIcon(wcx.hInstance, MAKEINTRESOURCE(IDI_APPLICATION));
       if (RegisterClassEx(&wcx)) { IsInitialized = -1; }
    }

    if (IsInitialized) {

       gh_Inst = hInstance; // Stocke le handle d'instance dans la variable globale

       long w = MyWindowWidth;
       long h = MyWindowHeight;
       long x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);
       long y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);

       DWORD dwStyle = WS_POPUP | WS_THICKFRAME | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX |
                       WS_MAXIMIZEBOX | WS_CLIPSIBLINGS | WS_CLIPCHILDREN; // | WS_VISIBLE

       gh_Main    = CreateWindowEx(
                    WS_EX_ACCEPTFILES,              // Optional window styles.
                    szWindowClass,                  // Window class
                    szTitle,                        // Window text
                    dwStyle,                        // Window style
                    // Size and position
                    x, -2000, w, h,
                    NULL,       // Parent window
                    NULL,       // Menu
                    hInstance,  // Instance handle
                    NULL        // Additional application data
                    );

       if (gh_Main) {
           WCHAR szExePath[MAX_PATH] = {0}; wcscpy_s(szExePath, (WCHAR*) EXEpath().c_str());
           wstring wS = (WCHAR*) szExePath; wS += L"ZWP.exe";
           WCHAR szRunProg[MAX_PATH] = {0}; wcscpy_s(szRunProg, (WCHAR*) wS.c_str());
           skTerminateProcess(szRunProg); // Kill any previous instance of ZWP.exe if any...

           gh_ImageCtrl = CreateWindowEx(0, GDImageClassName, NULL,
                                         WS_CHILD | WS_VISIBLE,
                                         78, 40, 628, 432,
                                         gh_Main, (HMENU) IDC_MAIN_GDIMAGE,
                                         hInstance, NULL);

           HWND hCtrl   = CreateWindowEx(0, L"MSCTLS_TRACKBAR32", NULL,
                                         WS_CHILD | WS_VISIBLE | WS_TABSTOP | TBS_VERT | TBS_BOTTOM | TBS_AUTOTICKS,
                                         728, 40, 32, 432,
                                         gh_Main, (HMENU) IDC_MAIN_SLIDEZOOM,
                                         hInstance, NULL);

           gs_Resource = (WCHAR*) szExePath; gs_Resource += L"Resource\\";
           gs_AudioPath = (WCHAR*) szExePath; gs_AudioPath += L"Audio\\";
           gs_PluginPath = (WCHAR*) szExePath; gs_PluginPath += L"BBPlugin\\";

           wstring ws = (WCHAR*) szExePath; ws.append(L"HUD.sks");
           if (skInitEngine ((WCHAR*) ws.c_str(), L"")) {

               skSkinWindow(gh_Main, L"Dock|Undock|Minimize|Maximize|Restore|Close");
               wstring sResource;

               // Anchor the SLIDEZOOM trackbar
               skSetAnchorCtrl(hCtrl, ANCHOR_HEIGHT_RIGHT);

               hCtrl = CreateWindowEx(0, L"BUTTON", L"Transparent HUD mode",
                                      WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX,
                                      500, 542, 200, 16,
                                      gh_Main, (HMENU) IDC_MAIN_CHECKBOX,
                                      hInstance, NULL);
               skSkinChildCtrl(hCtrl, 0), skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
               ZI_UseWinLIFTbackground(gh_ImageCtrl, TRUE, FALSE);

               hCtrl = CreateWindowEx(0, L"COMBOBOX", NULL,
                                      WS_CHILD | WS_VISIBLE | CBS_AUTOHSCROLL | CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP | CBS_HASSTRINGS,
                                      127, 542-49, 150, 164,
                                      gh_Main, (HMENU) IDC_CB_AUDIO,
                                      hInstance, NULL);
               DetectAudio(hCtrl, 1);
               skSkinChildCtrl(hCtrl, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);

               hCtrl = CreateWindowEx(WS_EX_TRANSPARENT, L"COMBOBOX", NULL,
                                      WS_CHILD | WS_VISIBLE | CBS_AUTOHSCROLL | CBS_DROPDOWNLIST | WS_VSCROLL | WS_TABSTOP | CBS_HASSTRINGS,
                                      127, 542-24, 150, 164,
                                      gh_Main, (HMENU) IDC_CB_PLUGIN,
                                      hInstance, NULL);
               DetectPlugin(hCtrl, 0);
               skSkinChildCtrl(hCtrl, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
               SendMessage(hCtrl, CB_GETLBTEXT, SendMessage(hCtrl, CB_GETCURSEL, 0, 0), (LPARAM) szFullpathToFile);

               wS = gs_PluginPath; wS += (WCHAR*) szFullpathToFile;
               WCHAR szPlaythis[MAX_PATH] = {0}; wcscpy_s(szPlaythis, (WCHAR*) wS.c_str());

               // Start the background plugin player.
               if (hZWP == 0) {
                   ShellExecuteA(0, "open", ws2s(szRunProg).c_str(), ws2s(szPlaythis).c_str(), ws2s(szExePath).c_str(), SW_SHOWNOACTIVATE);
               }

               hCtrl = CreateWindowEx(0, L"BUTTON", L"Use visual plugin", WS_CHILD | WS_VISIBLE | WS_TABSTOP | BS_AUTOCHECKBOX,
                                      127, 542, 150, 16, gh_Main, (HMENU) IDC_MAIN_PLUGIN, hInstance, NULL);
               skSkinChildCtrl(hCtrl, 0); skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);

               // Add a clock control.
               sResource = gs_Resource; sResource += L"Clock_09_92.png";
               hCtrl = skClockCtrl(gh_Main, (WCHAR*) sResource.c_str(), 4, 476, 0, 0, IDC_MAIN_CLOCK, 0x7FCB0000, 0x7F8F8F8F, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM);          // Anchor control
               skCreateToolTip(hCtrl, L"WinLIFT clock widget"); // Add tooltip.

               // Add a 5-state button image.
               sResource = gs_Resource; sResource += L"SelectImage.png";
               hCtrl = skButtonImage(gh_Main, (WCHAR*) sResource.c_str(), 780 - 58, 498, IDC_MAIN_LOADIMAGE, 5);
               skSetAnchorCtrl(hCtrl, ANCHOR_BOTTOM_RIGHT);
               skCreateToolTip(hCtrl, L"WinLIFT ButtonImage");

               // Add two circular slider gauges.
               sResource = gs_Resource; sResource += L"BTN_Gauge01.png";
               hCtrl = skKnobGauge(gh_Main, (WCHAR*) sResource.c_str(), 303, 527, 0, 0, IDC_MAIN_KNOBLEFT, 0, 0, 0, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
               skCreateToolTip(hCtrl, L"WinLIFT KnobGauge");
               hCtrl = skKnobGauge(gh_Main, (WCHAR*) sResource.c_str(), 436, 527, 0, 0, IDC_MAIN_KNOBRIGHT, 0, 0, 0, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
               skCreateToolTip(hCtrl, L"WinLIFT KnobGauge");

               // Add a circular slider gauge.
               sResource = gs_Resource; sResource += L"BTN_Gauge02.png";
               hCtrl = skKnobGauge(gh_Main, (WCHAR*) sResource.c_str(), 344, 476, 0, 0, IDC_MAIN_KNOBBIG, 0, 0, 0, 0);
               skSetAnchorCtrl(hCtrl, ANCHOR_CENTER_HORZ_BOTTOM);
               skCreateToolTip(hCtrl, L"WinLIFT KnobGauge");

               if (gh_ImageCtrl) {
                   RECT lpw;
                   POINT p;
                   GetWindowRect(gh_ImageCtrl, &lpw);
                   p.x = lpw.left, p.y = lpw.top;
                   ScreenToClient (gh_Main, &p);
                   skBorder(gh_ImageCtrl, p.x - 1, p.y - 1, lpw.right - lpw.left + 2, lpw.bottom - lpw.top + 2, 0, 1);
                   // Anchor the GDImage control.
                   skSetAnchorCtrl(gh_ImageCtrl, ANCHOR_HEIGHT_WIDTH);

                   // Compute the good range to use with the zoom slider.
                   long imgW = 0, imgH = 0, xP = 0, yP = 0, xS = 0, yS = 0;
                   ZI_GetImageSizeFromControl(gh_ImageCtrl, imgW, imgH);

                   ZI_Iconise(imgW, imgH, lpw.right - lpw.left, lpw.bottom - lpw.top, xP, yP, xS, yS);
                   if (imgW) {
                       hCtrl = GetDlgItem(gh_Main, IDC_MAIN_SLIDEZOOM);
                       SendMessage(hCtrl, TBM_SETPAGESIZE, 0, 1);
                       SendMessage(hCtrl, TBM_SETLINESIZE, 0, 1);
                       SendMessage(hCtrl, TBM_SETTICFREQ, 0, 1);
                       SendMessage(hCtrl, TBM_SETRANGE, 1, MAKELONG( 1, imgW));
                       SendMessage(hCtrl, TBM_SETPOS, 1, xS);
                   }

                   sResource = gs_Resource; sResource.append(L"homerem.ttf");
                   ws = L"DWM composition";
                   ZD_DrawTextToCtrl(gh_ImageCtrl, (WCHAR*) ws.c_str(),
                                    (lpw.right - lpw.left) - 300, 10, ZD_ARGB(255, 255,255,255),
                                    (WCHAR*) sResource.c_str(),
                                    30,                                  // font size in pixel
                                    ID_LOGO, ZS_VISIBLE,
                                    -1,                                  // shadow effect (offset in pixel)
                                    0);
                   ZD_SetObjectAnchorMode(ID_LOGO, ANCHOR_RIGHT);

                   // The animated sprite.
                   sResource = gs_Resource; sResource += L"sparkling.ski";
                   long nReserved = 0;
                   HBITMAP hBitmap = skSkiToDib ((WCHAR*) sResource.c_str(), nReserved);
                   ZI_GetBitmapSize(hBitmap, imgW, imgH);
                   ZD_DrawBitmapToCtrl(gh_ImageCtrl, (lpw.right - lpw.left) - (imgH - 40), -55, hBitmap, ZD_ColorARGB(255, 0), ID_SPIN01, ZS_VISIBLE);
                   ZD_SetObjectFrameCount(ID_SPIN01, (BYTE) (imgW / imgH));
                   ZD_SetObjectFrameToUse(ID_SPIN01, 1, FALSE);
                   // Set anchor mode
                   ZD_SetObjectAnchorMode(ID_SPIN01, ANCHOR_RIGHT);

                   // The animated sprite.
                   sResource = gs_Resource; sResource += L"triangle.ski";
                   nReserved = 0;
                   hBitmap = skSkiToDib ((WCHAR*) sResource.c_str(), nReserved);
                   ZI_GetBitmapSize(hBitmap, imgW, imgH);
                   ZD_DrawBitmapToCtrl(gh_ImageCtrl, 0, (lpw.bottom - lpw.top) - imgH, hBitmap, ZD_ColorARGB(255, 0), ID_SPIN02, ZS_VISIBLE);
                   ZD_SetObjectFrameCount(ID_SPIN02, (BYTE) (imgW / imgH));
                   ZD_SetObjectFrameToUse(ID_SPIN02, 1, FALSE);
                   // Set anchor mode
                   ZD_SetObjectAnchorMode(ID_SPIN02, ANCHOR_BOTTOM);

                   // The animated sprite.
                   sResource = gs_Resource; sResource += L"bighead.ski";
                   UseThisAnimation((WCHAR*) sResource.c_str(), ID_SPIN03);

               }
           }

           ShowWindow(gh_Main, SW_SHOW);

           // Resize the main window to 16/9.
           RECT lpw;
           GetWindowRect(gh_Main, &lpw);
           h = lpw.bottom - lpw.top; w = (long) (h * 1.77f); // Turn it to wide screen.
           x = max((GetSystemMetrics(SM_CXSCREEN) - w) / 2, 0);

           // Create a fall down effect animation.
           MoveWindow(gh_Main, x, lpw.top, w, h, 0);
           ShowWindow(gh_ImageCtrl, SW_HIDE);
           dwStyle = RDW_INVALIDATE | RDW_INTERNALPAINT | RDW_ERASE | RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME;
           for (k = -h ; k < 0 ; k += 8 ) { MoveWindow(gh_Main, x, k, w, h, 0); }
           for (k = 0; k <= y; k += 8) {
                MoveWindow(gh_Main, x, k, w, h, 0); RedrawWindow(gh_Main, NULL, NULL, dwStyle);
           }

           y = max((GetSystemMetrics(SM_CYSCREEN) - h) / 2, 0);
           MoveWindow(gh_Main, x, y, w, h, 0);

           StartAnimation(TIMER_DELAY);

           ShowWindow(gh_ImageCtrl, SW_SHOW);

           // Main message loop
           while (GetMessage(&msg, NULL, 0, 0)) {
               TranslateMessage(&msg);
               DispatchMessage(&msg);
           }
           nRet = (long) msg.wParam;
       }

    }
    return nRet;
}
